"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineChart = void 0;
var react_1 = __importStar(require("react"));
var chart_js_1 = __importDefault(require("chart.js"));
var ChartUtils_1 = require("../ChartUtils");
var themes_1 = require("../../../themes");
var ChartContainer_1 = require("./ChartContainer");
var ChartPatterns_1 = require("../ChartPatterns");
var translations_1 = require("../../../translations");
var LineChart = function (_a) {
    var title = _a.title, data = _a.data, siteVariables = _a.siteVariables, gradients = _a.gradients;
    var colorScheme = siteVariables.colorScheme, theme = siteVariables.theme, t = siteVariables.t;
    var canvasRef = react_1.default.useRef(null);
    var chartRef = react_1.default.useRef();
    var chartId = react_1.default.useMemo(function () { return Math.random().toString(36).substr(2, 9); }, []);
    var chartDataPointColors = react_1.default.useMemo(function () { return [
        colorScheme.brand.background,
        colorScheme.default.borderHover,
        colorScheme.brand.borderHover,
        colorScheme.default.foreground2,
        colorScheme.brand.background4,
        colorScheme.default.foreground,
    ]; }, [theme]);
    var createDataPoints = function () {
        return Array.from(data.datasets, function (set, i) {
            var dataPointConfig = {
                label: (0, translations_1.getText)(t.locale, set.label),
                data: set.data,
                borderColor: chartDataPointColors[i],
                hoverBorderColor: chartDataPointColors[i],
                hoverBorderWidth: 2,
                backgroundColor: "transparent",
                hoverBackgroundColor: "transparent",
                borderWidth: 2,
                pointBorderColor: chartDataPointColors[i],
                pointBackgroundColor: chartDataPointColors[i],
                pointHoverBackgroundColor: chartDataPointColors[i],
                pointHoverBorderColor: chartDataPointColors[i],
                pointHoverBorderWidth: 0,
                borderCapStyle: "round",
                borderJoinStyle: "round",
                pointBorderWidth: 0,
                pointRadius: 2,
                pointHoverRadius: 2,
                pointStyle: "circle",
                borderDash: [],
            };
            if (theme === themes_1.TeamsTheme.HighContrast) {
                dataPointConfig = __assign(__assign({}, dataPointConfig), { borderColor: colorScheme.brand.background, hoverBorderColor: colorScheme.default.borderHover, pointBorderColor: colorScheme.brand.background, pointBackgroundColor: colorScheme.brand.background, pointHoverBackgroundColor: colorScheme.brand.background, pointHoverBorderColor: colorScheme.brand.background, hoverBorderWidth: 4, pointRadius: 4, pointHoverRadius: 4, pointStyle: ChartPatterns_1.lineChartPatterns[i].pointStyle, borderDash: ChartPatterns_1.lineChartPatterns[i].lineBorderDash });
            }
            return dataPointConfig;
        });
    };
    var createAreaChartDataPoints = function (ctx) {
        return Array.from(data.datasets, function (set, i) {
            var gradientStroke = ctx.createLinearGradient(0, 0, 0, ctx.canvas.clientHeight * 0.8);
            var hoverGradientStroke = ctx.createLinearGradient(0, 0, 0, ctx.canvas.clientHeight * 0.8);
            if (theme === themes_1.TeamsTheme.HighContrast) {
                var colorRGB = (0, ChartUtils_1.hexToRgb)(colorScheme.brand.background);
                var hoverColorRGB = (0, ChartUtils_1.hexToRgb)(colorScheme.default.borderHover);
                gradientStroke.addColorStop(0, "rgba(".concat(colorRGB, ", .2)"));
                gradientStroke.addColorStop(1, "rgba(".concat(colorRGB, ", .0)"));
                hoverGradientStroke.addColorStop(0, "rgba(".concat(hoverColorRGB, ", .4)"));
                hoverGradientStroke.addColorStop(1, "rgba(".concat(hoverColorRGB, ", .0)"));
            }
            else {
                var colorRGB = (0, ChartUtils_1.hexToRgb)(chartDataPointColors[i]);
                gradientStroke.addColorStop(0, "rgba(".concat(colorRGB, ", .4)"));
                gradientStroke.addColorStop(1, "rgba(".concat(colorRGB, ", .0)"));
                hoverGradientStroke.addColorStop(0, "rgba(".concat(colorRGB, ", .6)"));
                hoverGradientStroke.addColorStop(1, "rgba(".concat(colorRGB, ", .0)"));
            }
            var dataPointConfig = {
                label: (0, translations_1.getText)(t.locale, set.label),
                data: set.data,
                borderColor: chartDataPointColors[i],
                hoverBorderColor: chartDataPointColors[i],
                hoverBorderWidth: 2,
                backgroundColor: gradientStroke,
                hoverBackgroundColor: hoverGradientStroke,
                borderWidth: 2,
                pointBorderColor: chartDataPointColors[i],
                pointBackgroundColor: chartDataPointColors[i],
                pointHoverBackgroundColor: chartDataPointColors[i],
                pointHoverBorderColor: chartDataPointColors[i],
                pointHoverBorderWidth: 0,
                borderCapStyle: "round",
                borderJoinStyle: "round",
                pointBorderWidth: 0,
                pointRadius: 2,
                pointHoverRadius: 2,
                pointStyle: "circle",
                borderDash: [],
            };
            if (theme === themes_1.TeamsTheme.HighContrast) {
                dataPointConfig = __assign(__assign({}, dataPointConfig), { borderColor: colorScheme.brand.background, hoverBorderColor: colorScheme.default.borderHover, pointBorderColor: colorScheme.brand.background, pointBackgroundColor: colorScheme.brand.background, pointHoverBackgroundColor: colorScheme.brand.background, pointHoverBorderColor: colorScheme.brand.background, hoverBorderWidth: 4, pointRadius: 4, pointHoverRadius: 4, pointStyle: ChartPatterns_1.lineChartPatterns[i].pointStyle, borderDash: ChartPatterns_1.lineChartPatterns[i].lineBorderDash });
            }
            return dataPointConfig;
        });
    };
    (0, react_1.useEffect)(function () {
        var selectedIndex = -1;
        var selectedDataSet = 0;
        if (!canvasRef.current)
            return;
        var ctx = canvasRef.current.getContext("2d");
        if (!ctx)
            return;
        chartRef.current = new chart_js_1.default(ctx, __assign(__assign({}, (0, ChartUtils_1.chartConfig)({ type: "line" })), { data: {
                labels: Array.isArray(data.labels)
                    ? data.labels.map(function (label) { return (0, translations_1.getText)(t.locale, label); })
                    : (0, translations_1.getText)(t.locale, data.labels),
                datasets: [],
            }, plugins: [
                {
                    afterDatasetsDraw: function (_a) {
                        var ctx = _a.ctx, tooltip = _a.tooltip, chart = _a.chart;
                        (0, ChartUtils_1.tooltipAxisYLine)({
                            chart: chart,
                            ctx: ctx,
                            tooltip: tooltip,
                        });
                    },
                },
            ] }));
        var chart = chartRef.current;
        /**
         * Keyboard manipulations
         */
        function meta() {
            return chart.getDatasetMeta(selectedDataSet);
        }
        function removeFocusStyleOnClick() {
            // Remove focus state style if selected by mouse
            if (canvasRef.current) {
                canvasRef.current.style.boxShadow = "none";
            }
        }
        function removeDataPointsHoverStates() {
            var datasetMeta = meta();
            if (selectedIndex > -1 && datasetMeta.data[selectedIndex]) {
                datasetMeta.controller.removeHoverStyle(datasetMeta.data[selectedIndex], 0, selectedIndex);
            }
        }
        function hoverDataPoint(pointID) {
            var datasetMeta = meta();
            if (datasetMeta.data[pointID])
                datasetMeta.controller.setHoverStyle(datasetMeta.data[pointID], selectedDataSet, pointID);
        }
        function showFocusedDataPoint() {
            var _a;
            hoverDataPoint(selectedIndex);
            (0, ChartUtils_1.tooltipTrigger)({
                chart: chartRef.current,
                data: data,
                set: selectedDataSet,
                index: selectedIndex,
                siteVariables: siteVariables,
            });
            (_a = document
                .getElementById("".concat(chartId, "-tooltip-").concat(selectedDataSet, "-").concat(selectedIndex))) === null || _a === void 0 ? void 0 : _a.focus();
        }
        function resetChartStates() {
            removeDataPointsHoverStates();
            var activeElements = chart.tooltip._active;
            var requestedElem = chart.getDatasetMeta(selectedDataSet).data[selectedIndex];
            activeElements.find(function (v, i) {
                if (requestedElem._index === v._index) {
                    activeElements.splice(i, 1);
                    return true;
                }
            });
            for (var i = 0; i < activeElements.length; i++) {
                if (requestedElem._index === activeElements[i]._index) {
                    activeElements.splice(i, 1);
                    break;
                }
            }
            if (theme === themes_1.TeamsTheme.HighContrast) {
                chart.data.datasets.map(function (dataset) {
                    dataset.borderColor = colorScheme.default.border;
                    dataset.borderWidth = 2;
                });
                chart.update();
            }
            chart.tooltip._active = activeElements;
            chart.tooltip.update(true);
            chart.draw();
        }
        function changeFocus(e) {
            removeDataPointsHoverStates();
            var datasetMeta = meta();
            switch (e.key) {
                case "ArrowRight":
                    e.preventDefault();
                    selectedIndex = (selectedIndex + 1) % datasetMeta.data.length;
                    break;
                case "ArrowLeft":
                    e.preventDefault();
                    selectedIndex = (selectedIndex || datasetMeta.data.length) - 1;
                    break;
                case "ArrowUp":
                case "ArrowDown":
                    e.preventDefault();
                    if (data.datasets.length > 1) {
                        // Get all values for the current data point
                        var values_1 = data.datasets.map(function (dataset) { return dataset.data[selectedIndex]; });
                        // Sort an array to define next available number
                        var sorted_1 = __spreadArray([], Array.from(new Set(values_1)), true).sort(function (a, b) { return Number(a) - Number(b); });
                        var nextValue_1 = sorted_1[sorted_1.findIndex(function (v) { return v === values_1[selectedDataSet]; }) +
                            (e.key === "ArrowUp" ? 1 : -1)];
                        // Find dataset ID by the next higher number after current
                        var nextDataSet = values_1.findIndex(function (v) { return v === nextValue_1; });
                        // If there is no next number that could selected, get number from oposite side
                        if (nextDataSet < 0) {
                            nextDataSet = values_1.findIndex(function (v) {
                                return v ===
                                    sorted_1[e.key === "ArrowUp" ? 0 : data.datasets.length - 1];
                            });
                        }
                        selectedDataSet = nextDataSet;
                        selectedIndex = selectedIndex % datasetMeta.data.length;
                    }
                    break;
            }
            showFocusedDataPoint();
        }
        canvasRef.current.addEventListener("click", removeFocusStyleOnClick);
        canvasRef.current.addEventListener("keydown", changeFocus);
        canvasRef.current.addEventListener("focusout", resetChartStates);
        return function () {
            if (!chartRef.current)
                return;
            if (canvasRef.current) {
                canvasRef.current.removeEventListener("click", removeFocusStyleOnClick);
                canvasRef.current.removeEventListener("keydown", changeFocus);
                canvasRef.current.removeEventListener("focusout", resetChartStates);
            }
            chartRef.current.destroy();
        };
    }, []);
    /**
     * Theme updates
     */
    (0, react_1.useEffect)(function () {
        if (!chartRef.current)
            return;
        if (!canvasRef.current)
            return;
        var ctx = canvasRef.current.getContext("2d");
        if (!ctx)
            return;
        // Apply new colors scheme for data points
        chartRef.current.data.datasets = gradients
            ? createAreaChartDataPoints(ctx)
            : createDataPoints();
        // Update tooltip colors scheme
        (0, ChartUtils_1.setTooltipColorScheme)({
            chart: chartRef.current,
            siteVariables: siteVariables,
            chartDataPointColors: chartDataPointColors,
        });
        // Update axeses
        (0, ChartUtils_1.axesConfig)({ chart: chartRef.current, ctx: ctx, colorScheme: colorScheme });
        // Show style changes
        chartRef.current.update();
    }, [theme]);
    function onLegendClick(datasetIndex) {
        if (!chartRef.current)
            return;
        chartRef.current.data.datasets[datasetIndex].hidden =
            !chartRef.current.data.datasets[datasetIndex].hidden;
        chartRef.current.update();
    }
    return (react_1.default.createElement(ChartContainer_1.ChartContainer, { siteVariables: siteVariables, data: data, chartDataPointColors: chartDataPointColors, onLegendClick: onLegendClick },
        react_1.default.createElement("canvas", { id: chartId, ref: canvasRef, tabIndex: 0, style: {
                userSelect: "none",
            }, "aria-label": title }, data.datasets.map(function (set, setKey) {
            return set.data.forEach(function (item, itemKey) { return (
            // Generated tooltips for screen readers
            react_1.default.createElement("div", { key: itemKey, id: "".concat(chartId, "-tooltip-").concat(setKey, "-").concat(itemKey) },
                react_1.default.createElement("p", null, item),
                react_1.default.createElement("span", null,
                    (0, translations_1.getText)(t.locale, set.label),
                    ": ",
                    set.data[itemKey]))); });
        }))));
};
exports.LineChart = LineChart;
//# sourceMappingURL=Line.js.map