import { ThemePrepared } from "@fluentui/react-northstar";
import { TDashboardInteraction } from "./Dashboard";
import { TTextObject, TTranslations } from "../../translations";
/**
 * An action item displayed in a widget’s overflow menu.
 * @public
 */
export interface IWidgetAction {
    /**
     * A unique ID to use to refer to the action.
     */
    id: string;
    /**
     * The icon
     */
    icon?: string;
    /**
     * The text content of the trigger for the action.
     */
    title: TTextObject;
}
interface IDashboardCallout {
    widgetId: string;
    globalTheme: ThemePrepared;
    calloutType?: "overflow" | "filter";
    widgetCalloutGroup?: IWidgetAction[];
    hideWidget?: (widgetId: string) => void;
    setActiveFilter?: (filterId: string) => void;
    activeFilter?: string;
    t: TTranslations;
    onInteraction?: (interaction: TDashboardInteraction) => void;
}
export declare const DashboardCallout: ({ widgetId, globalTheme, calloutType, widgetCalloutGroup, hideWidget, setActiveFilter, activeFilter, t, onInteraction, }: IDashboardCallout) => JSX.Element;
export {};
//# sourceMappingURL=DashboardCallout.d.ts.map