"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DashboardCallout = void 0;
var react_1 = __importStar(require("react"));
var react_northstar_1 = require("@fluentui/react-northstar");
var themes_1 = require("../../themes");
var Icon_1 = __importDefault(require("../../lib/Icon"));
var translations_1 = require("../../translations");
var getLocalTheme = function () {
    return {
        componentVariables: {
            PopupContent: function (_a) {
                var colorScheme = _a.colorScheme, borderRadius = _a.borderRadius, borderWidth = _a.borderWidth, shadowLevel1 = _a.shadowLevel1, shadowLevel4 = _a.shadowLevel4, theme = _a.theme;
                return ({
                    backgroundColor: colorScheme.grey.background,
                    backgroundColorHover: colorScheme.grey.background,
                    boxShadow: "".concat(shadowLevel1, ", ").concat(shadowLevel4),
                    borderRadius: borderRadius,
                    borderSize: borderWidth,
                    borderColor: theme === themes_1.TeamsTheme.HighContrast
                        ? colorScheme.grey.backgroundFocus
                        : "transparent",
                    borderColorHover: theme === themes_1.TeamsTheme.HighContrast
                        ? colorScheme.grey.backgroundFocus
                        : "transparent",
                });
            },
        },
        componentStyles: {
            Menu: {
                root: {
                    width: "100%",
                    marginRight: "0",
                    marginLeft: "0",
                    border: "none",
                    padding: "0 0.25rem",
                },
            },
            MenuDivider: {
                root: { margin: "0.25rem 0" },
            },
            PopupContent: {
                content: {
                    width: "12.5rem",
                    padding: "0",
                    boxShadow: " 0px 1.2px 3.6px rgba(0, 0, 0, 0.11), 0px 6.4px 14.4px rgba(0, 0, 0, 0.13)",
                },
            },
        },
    };
};
var DashboardCallout = function (_a) {
    var widgetId = _a.widgetId, globalTheme = _a.globalTheme, _b = _a.calloutType, calloutType = _b === void 0 ? "overflow" : _b, widgetCalloutGroup = _a.widgetCalloutGroup, hideWidget = _a.hideWidget, setActiveFilter = _a.setActiveFilter, activeFilter = _a.activeFilter, t = _a.t, onInteraction = _a.onInteraction;
    var theme = (0, react_northstar_1.mergeThemes)(globalTheme, getLocalTheme());
    var _c = (0, react_1.useState)(false), open = _c[0], setOpen = _c[1];
    var hideWidgetAction = {
        id: "hide_widget",
        content: t["hide widget"],
        icon: react_1.default.createElement(react_northstar_1.EyeSlashIcon, null),
        onClick: function () { return hideWidget && hideWidget(widgetId); },
    };
    var menuItems = calloutType === "filter"
        ? widgetCalloutGroup
            ? widgetCalloutGroup.map(function (_a) {
                var id = _a.id, title = _a.title;
                var selected = activeFilter === id;
                return {
                    key: id,
                    role: "option",
                    "aria-selected": selected,
                    content: (0, translations_1.getText)(t.locale, title),
                    icon: (react_1.default.createElement(react_northstar_1.AcceptIcon, { outline: true, styles: { visibility: selected ? "visible" : "hidden" } })),
                    onClick: function () {
                        setActiveFilter && setActiveFilter(id);
                        setOpen(false);
                    },
                };
            })
            : []
        : widgetCalloutGroup
            ? __spreadArray(__spreadArray([], widgetCalloutGroup.map(function (_a) {
                var id = _a.id, icon = _a.icon, title = _a.title;
                return __assign(__assign({ key: id, content: (0, translations_1.getText)(t.locale, title) }, (icon && { icon: react_1.default.createElement(Icon_1.default, { icon: icon }) })), (onInteraction && {
                    onClick: function () {
                        onInteraction({
                            event: "click",
                            target: "action",
                            widget: widgetId,
                            action: id,
                        });
                        setOpen(false);
                    },
                }));
            }), true), (hideWidget ? [{ kind: "divider" }, hideWidgetAction] : []), true) : [hideWidgetAction];
    return (react_1.default.createElement(react_northstar_1.Provider, { theme: theme }, (hideWidget || widgetCalloutGroup) && (react_1.default.createElement(react_northstar_1.Popup, { offset: [0, 0], position: "below", open: open, onOpenChange: function (_, props) { return setOpen(!!(props === null || props === void 0 ? void 0 : props.open)); }, trigger: react_1.default.createElement(react_northstar_1.Button, { text: true, iconOnly: true, "aria-label": t["more"], icon: calloutType === "filter" ? (react_1.default.createElement(react_northstar_1.FilterIcon, { outline: true })) : (react_1.default.createElement(react_northstar_1.MoreIcon, { outline: true })), styles: {
                margin: "0 -0.35rem",
            } }), content: {
            styles: { width: "12.5rem" },
            content: react_1.default.createElement(react_northstar_1.Menu, { items: menuItems, vertical: true }),
        }, trapFocus: {
            firstFocusableSelector: ".extended-toolbar__filters-menu__tree [data-is-focusable=true]",
        } }))));
};
exports.DashboardCallout = DashboardCallout;
//# sourceMappingURL=DashboardCallout.js.map