"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Widget = exports.EWidgetSize = void 0;
var react_1 = __importStar(require("react"));
var react_northstar_1 = require("@fluentui/react-northstar");
var DashboardCallout_1 = require("./DashboardCallout");
var Chart_1 = require("../Chart/Chart");
var Placeholder_1 = require("./Placeholder");
var translations_1 = require("../../translations");
var DescriptionList_1 = require("./DescriptionList");
/**
 * The widget’s target size in the Dashboard’s grid layout.
 * @public
 */
var EWidgetSize;
(function (EWidgetSize) {
    /**
     * The widget will occupy 1×1 grid cells.
     */
    EWidgetSize["Single"] = "single";
    /**
     * The widget will occupy 2×1 grid cells.
     */
    EWidgetSize["Double"] = "double";
    /**
     * The widget will occupy 3×1 grid cells.
     */
    EWidgetSize["Triple"] = "triple";
    /**
     * The widget will occupy 2×2 grid cells.
     */
    EWidgetSize["Box"] = "box";
})(EWidgetSize = exports.EWidgetSize || (exports.EWidgetSize = {}));
var Widget = function (_a) {
    var id = _a.id, size = _a.size, body = _a.body, bodyByFilter = _a.bodyByFilter, link = _a.link, title = _a.title, desc = _a.desc, widgetActionGroup = _a.widgetActionGroup, widgetFilterGroup = _a.widgetFilterGroup, initialFilter = _a.initialFilter, hideWidget = _a.hideWidget, onInteraction = _a.onInteraction;
    var cardStyle = {
        gridColumnEnd: "auto",
        gridRowEnd: "auto",
        "@media (max-width: 842px)": {
            gridColumnEnd: "span 3",
        },
    };
    if (size === EWidgetSize.Double) {
        cardStyle.gridColumnEnd = "span 2";
    }
    if (size === EWidgetSize.Box) {
        cardStyle.gridColumnEnd = "span 2";
        cardStyle.gridRowEnd = "span 2";
    }
    if (size === EWidgetSize.Triple) {
        cardStyle.gridColumnEnd = "span 3";
    }
    var _b = (0, react_1.useState)(0), activeTabId = _b[0], setActiveTabId = _b[1];
    var _c = (0, react_1.useState)(widgetFilterGroup && bodyByFilter
        ? initialFilter || widgetFilterGroup[0].id
        : null), activeFilter = _c[0], setActiveFilter = _c[1];
    var activeBody = (activeFilter && bodyByFilter && bodyByFilter[activeFilter]) || body;
    return (react_1.default.createElement(react_northstar_1.Card, { styles: cardStyle, fluid: true },
        react_1.default.createElement(react_northstar_1.ProviderConsumer, { render: function (globalTheme) {
                var _a = globalTheme.siteVariables, t = _a.t, rtl = _a.rtl;
                return (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(react_northstar_1.Card.Header, null,
                        react_1.default.createElement(react_northstar_1.Flex, { gap: "gap.small", styles: { minHeight: "2rem", marginBlockStart: "-.5rem" } },
                            react_1.default.createElement(react_northstar_1.Flex, { gap: "gap.small", column: true, styles: { marginBlockStart: ".25rem" } },
                                react_1.default.createElement(react_northstar_1.Text, { content: (0, translations_1.getText)(t.locale, title), style: { margin: 0 }, weight: "bold" }),
                                desc && (react_1.default.createElement(react_northstar_1.Text, { content: (0, translations_1.getText)(t.locale, desc), size: "small" }))),
                            react_1.default.createElement(react_northstar_1.Box, { role: "none", styles: { flex: "1 0 0" } }),
                            activeFilter && (react_1.default.createElement(DashboardCallout_1.DashboardCallout, __assign({}, {
                                widgetId: id,
                                globalTheme: globalTheme,
                                calloutType: "filter",
                                widgetCalloutGroup: widgetFilterGroup,
                                setActiveFilter: setActiveFilter,
                                activeFilter: activeFilter,
                                t: t,
                                onInteraction: onInteraction,
                            }))),
                            react_1.default.createElement(DashboardCallout_1.DashboardCallout, __assign({}, {
                                widgetId: id,
                                globalTheme: globalTheme,
                                widgetCalloutGroup: widgetActionGroup,
                                hideWidget: hideWidget,
                                t: t,
                                onInteraction: onInteraction,
                            })))),
                    react_1.default.createElement(react_northstar_1.Card.Body, { style: {
                            marginBottom: "0.75rem",
                            height: "100%",
                            overflow: "hidden",
                        }, fitted: true }, activeBody ? (react_1.default.createElement(react_1.default.Fragment, null,
                        activeBody.length > 1 && (react_1.default.createElement(react_northstar_1.Menu, { style: {
                                border: "none",
                                background: "none",
                                marginBottom: "1.25rem",
                            }, items: Array.from(activeBody, function (_a) {
                                var id = _a.id, title = _a.title;
                                return Object.assign({
                                    key: id,
                                    content: (0, translations_1.getText)(t.locale, title),
                                });
                            }), activeIndex: activeTabId, onItemClick: function (_a, props) {
                                var currentTarget = _a.currentTarget;
                                return setActiveTabId(props && props.index ? props.index : 0);
                            }, accessibility: react_northstar_1.tabListBehavior, underlined: true, primary: true })),
                        activeBody.map(function (_a, i) {
                            var id = _a.id, content = _a.content;
                            return (react_1.default.createElement(react_northstar_1.Flex, { key: id, styles: {
                                    height: "100%",
                                    display: activeTabId === i ? "flex" : "none",
                                }, column: true }, (function () {
                                switch (content.type) {
                                    case "chart":
                                        return (react_1.default.createElement(Chart_1.Chart, __assign({ key: "widget-chart__".concat(activeFilter || "", "__").concat(i) }, content.chart)));
                                    case "dl":
                                        return (react_1.default.createElement(DescriptionList_1.DescriptionList, { t: t, list: content
                                                .list }));
                                    case "placeholder":
                                        return (react_1.default.createElement(Placeholder_1.Placeholder, { message: content
                                                .message }));
                                    case "text":
                                        return (react_1.default.createElement(react_northstar_1.Text, { as: "p", styles: {
                                                marginBlockStart: 0,
                                                marginBlockEnd: 0,
                                            } }, (0, translations_1.getText)(t.locale, content.text)));
                                }
                            })()));
                        }))) : (react_1.default.createElement(EmptyState, { borderColor: globalTheme.siteVariables.colors.grey["300"] }))),
                    link && (react_1.default.createElement(react_northstar_1.Card.Footer, { fitted: true },
                        react_1.default.createElement(react_northstar_1.Flex, { space: "between", vAlign: "center" }, link.hasOwnProperty("href") ? (react_1.default.createElement(react_northstar_1.Text, { as: "a", href: link.href, target: "_blank", size: "small", color: "brand", styles: {
                                textDecoration: "none",
                                "&:focus": {
                                    outlineColor: globalTheme.siteVariables.colorScheme.default
                                        .foregroundActive,
                                },
                            } },
                            link.title
                                ? (0, translations_1.getText)(t.locale, link.title)
                                : t["view more"],
                            rtl ? (react_1.default.createElement(react_northstar_1.ArrowLeftIcon, { size: "small", styles: { margin: "0 .4rem" } })) : (react_1.default.createElement(react_northstar_1.ArrowRightIcon, { size: "small", styles: { margin: "0 .4rem" } })))) : link.hasOwnProperty("actionId") ? (react_1.default.createElement(react_1.default.Fragment, null,
                            react_1.default.createElement(react_northstar_1.Button, { text: true, size: "small", content: react_1.default.createElement(react_northstar_1.Text, { color: "brand" },
                                    link.title
                                        ? (0, translations_1.getText)(t.locale, link.title)
                                        : t["view more"],
                                    rtl ? (react_1.default.createElement(react_northstar_1.ArrowLeftIcon, { size: "small", styles: { margin: "0 .4rem" } })) : (react_1.default.createElement(react_northstar_1.ArrowRightIcon, { size: "small", styles: { margin: "0 .4rem" } }))), onClick: function () {
                                    return onInteraction &&
                                        onInteraction({
                                            event: "click",
                                            target: "widget",
                                            widget: id,
                                            subject: link.actionId,
                                        });
                                }, variables: function (_a) {
                                    var colorScheme = _a.colorScheme;
                                    return ({
                                        color: colorScheme.brand.foreground,
                                    });
                                } }))) : null)))));
            } })));
};
exports.Widget = Widget;
var EmptyState = function (_a) {
    var borderColor = _a.borderColor;
    return (react_1.default.createElement(react_northstar_1.Box, { styles: {
            height: "100%",
            border: "1px dashed ".concat(borderColor),
        } }));
};
//# sourceMappingURL=DashboardWidget.js.map