import { SvgIconProps } from "@fluentui/react-icons-northstar";
import { TLocale, TTextObject } from "../translations";
export interface ITooltipProps {
    content: TTextObject;
}
/**
 * An icon.
 * @public
 */
export interface IIconProps {
    icon?: string;
}
interface IIconComponentProps extends IIconProps, Pick<SvgIconProps, "styles"> {
}
/**
 * An icon which invokes a tooltip when focused.
 * @public
 */
export interface IFocusableIconProps extends IIconProps {
    tooltip: ITooltipProps;
}
interface IFocusableIconComponentProps extends IFocusableIconProps, Pick<SvgIconProps, "styles"> {
    locale: TLocale;
}
export declare const FocusableIcon: ({ tooltip: { content }, locale, styles, ...iconProps }: IFocusableIconComponentProps) => JSX.Element;
declare const Icon: ({ icon, styles }: IIconComponentProps) => JSX.Element | null;
export default Icon;
//# sourceMappingURL=Icon.d.ts.map