"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FocusableIcon = void 0;
var react_1 = __importDefault(require("react"));
var react_northstar_1 = require("@fluentui/react-northstar");
var translations_1 = require("../translations");
var Icons = {
    AcceptIcon: react_northstar_1.AcceptIcon,
    AddIcon: react_northstar_1.AddIcon,
    ApprovalsAppbarIcon: react_northstar_1.ApprovalsAppbarIcon,
    AppsIcon: react_northstar_1.AppsIcon,
    ArchiveIcon: react_northstar_1.ArchiveIcon,
    ArrowDownIcon: react_northstar_1.ArrowDownIcon,
    ArrowLeftIcon: react_northstar_1.ArrowLeftIcon,
    ArrowRightIcon: react_northstar_1.ArrowRightIcon,
    ArrowSortIcon: react_northstar_1.ArrowSortIcon,
    ArrowUpIcon: react_northstar_1.ArrowUpIcon,
    AudienceIcon: react_northstar_1.AudienceIcon,
    AudioLoadingIcon: react_northstar_1.AudioLoadingIcon,
    AudioOffIcon: react_northstar_1.AudioOffIcon,
    AttendeeIcon: react_northstar_1.AttendeeIcon,
    BanIcon: react_northstar_1.BanIcon,
    BellIcon: react_northstar_1.BellIcon,
    BellSlashIcon: react_northstar_1.BellSlashIcon,
    BellSnoozeIcon: react_northstar_1.BellSnoozeIcon,
    BluetoothIcon: react_northstar_1.BluetoothIcon,
    BoldIcon: react_northstar_1.BoldIcon,
    BookmarkIcon: react_northstar_1.BookmarkIcon,
    BreakoutRoomIcon: react_northstar_1.BreakoutRoomIcon,
    BroadcastIcon: react_northstar_1.BroadcastIcon,
    BroadcastViewFullscreenIcon: react_northstar_1.BroadcastViewFullscreenIcon,
    BroadcastViewLeftIcon: react_northstar_1.BroadcastViewLeftIcon,
    BulletsIcon: react_northstar_1.BulletsIcon,
    CalendarIcon: react_northstar_1.CalendarIcon,
    CalendarAgendaIcon: react_northstar_1.CalendarAgendaIcon,
    CallBlockedIcon: react_northstar_1.CallBlockedIcon,
    CallControlCloseTrayIcon: react_northstar_1.CallControlCloseTrayIcon,
    CallControlReleaseIcon: react_northstar_1.CallControlReleaseIcon,
    CallControlRequestIcon: react_northstar_1.CallControlRequestIcon,
    CallControlPresentNewIcon: react_northstar_1.CallControlPresentNewIcon,
    CallControlShareIcon: react_northstar_1.CallControlShareIcon,
    CallControlStopPresentingNewIcon: react_northstar_1.CallControlStopPresentingNewIcon,
    CallDialpadIcon: react_northstar_1.CallDialpadIcon,
    CallEndIcon: react_northstar_1.CallEndIcon,
    CallIcon: react_northstar_1.CallIcon,
    CallPstnIcon: react_northstar_1.CallPstnIcon,
    CallRecordingIcon: react_northstar_1.CallRecordingIcon,
    CallVideoIcon: react_northstar_1.CallVideoIcon,
    CallVideoOffIcon: react_northstar_1.CallVideoOffIcon,
    CameraIcon: react_northstar_1.CameraIcon,
    CanvasAddPageIcon: react_northstar_1.CanvasAddPageIcon,
    CallMissedLineIcon: react_northstar_1.CallMissedLineIcon,
    CallParkingIcon: react_northstar_1.CallParkingIcon,
    CastingIcon: react_northstar_1.CastingIcon,
    ChannelShareIcon: react_northstar_1.ChannelShareIcon,
    ChatIcon: react_northstar_1.ChatIcon,
    ChatOffIcon: react_northstar_1.ChatOffIcon,
    CheckmarkCircleIcon: react_northstar_1.CheckmarkCircleIcon,
    ChevronDownIcon: react_northstar_1.ChevronDownIcon,
    ChevronDownMediumIcon: react_northstar_1.ChevronDownMediumIcon,
    ChevronEndIcon: react_northstar_1.ChevronEndIcon,
    ChevronEndMediumIcon: react_northstar_1.ChevronEndMediumIcon,
    ChevronStartIcon: react_northstar_1.ChevronStartIcon,
    CircleIcon: react_northstar_1.CircleIcon,
    ClipboardCopiedToIcon: react_northstar_1.ClipboardCopiedToIcon,
    ClosedCaptionsIcon: react_northstar_1.ClosedCaptionsIcon,
    CloseIcon: react_northstar_1.CloseIcon,
    CodeSnippetIcon: react_northstar_1.CodeSnippetIcon,
    CollapseIcon: react_northstar_1.CollapseIcon,
    CompanionIcon: react_northstar_1.CompanionIcon,
    ComposeIcon: react_northstar_1.ComposeIcon,
    ComputerAudioIcon: react_northstar_1.ComputerAudioIcon,
    ComputerAudioOffIcon: react_northstar_1.ComputerAudioOffIcon,
    ConferenceRoomDeviceIcon: react_northstar_1.ConferenceRoomDeviceIcon,
    ContactCardIcon: react_northstar_1.ContactCardIcon,
    ContactGroupCallIcon: react_northstar_1.ContactGroupCallIcon,
    ContactGroupIcon: react_northstar_1.ContactGroupIcon,
    ContentIcon: react_northstar_1.ContentIcon,
    CustomerHubIcon: react_northstar_1.CustomerHubIcon,
    DoorArrowLeftIcon: react_northstar_1.DoorArrowLeftIcon,
    DownloadIcon: react_northstar_1.DownloadIcon,
    EditIcon: react_northstar_1.EditIcon,
    EmailIcon: react_northstar_1.EmailIcon,
    EmailWithDotIcon: react_northstar_1.EmailWithDotIcon,
    EmojiIcon: react_northstar_1.EmojiIcon,
    EmojiSadIcon: react_northstar_1.EmojiSadIcon,
    EmojiSurprisedIcon: react_northstar_1.EmojiSurprisedIcon,
    ErrorIcon: react_northstar_1.ErrorIcon,
    ExcelColorIcon: react_northstar_1.ExcelColorIcon,
    ExcelIcon: react_northstar_1.ExcelIcon,
    ExclamationCircleIcon: react_northstar_1.ExclamationCircleIcon,
    ExclamationTriangleIcon: react_northstar_1.ExclamationTriangleIcon,
    ExpandIcon: react_northstar_1.ExpandIcon,
    EyeIcon: react_northstar_1.EyeIcon,
    EyeFriendlierIcon: react_northstar_1.EyeFriendlierIcon,
    EyeSlashIcon: react_northstar_1.EyeSlashIcon,
    FilesAftereffectsIcon: react_northstar_1.FilesAftereffectsIcon,
    FilesCodeIcon: react_northstar_1.FilesCodeIcon,
    FilesEmptyIcon: react_northstar_1.FilesEmptyIcon,
    FilesErrorIcon: react_northstar_1.FilesErrorIcon,
    FilesFlashIcon: react_northstar_1.FilesFlashIcon,
    FilesGenericColoredIcon: react_northstar_1.FilesGenericColoredIcon,
    FilesGifIcon: react_northstar_1.FilesGifIcon,
    FilesHtmlColoredIcon: react_northstar_1.FilesHtmlColoredIcon,
    FilesIllustratorIcon: react_northstar_1.FilesIllustratorIcon,
    FilesImageIcon: react_northstar_1.FilesImageIcon,
    FilesIndesignIcon: react_northstar_1.FilesIndesignIcon,
    FilesOneNoteIcon: react_northstar_1.FilesOneNoteIcon,
    FilesPdfColoredIcon: react_northstar_1.FilesPdfColoredIcon,
    FilesPdfIcon: react_northstar_1.FilesPdfIcon,
    FilesPhotoshopIcon: react_northstar_1.FilesPhotoshopIcon,
    FilesPictureColoredIcon: react_northstar_1.FilesPictureColoredIcon,
    FilesSketchIcon: react_northstar_1.FilesSketchIcon,
    FilesSoundIcon: react_northstar_1.FilesSoundIcon,
    FilesTextColoredIcon: react_northstar_1.FilesTextColoredIcon,
    FilesTxtIcon: react_northstar_1.FilesTxtIcon,
    FilesUploadIcon: react_northstar_1.FilesUploadIcon,
    FilesVideoIcon: react_northstar_1.FilesVideoIcon,
    FilesZipIcon: react_northstar_1.FilesZipIcon,
    FilterIcon: react_northstar_1.FilterIcon,
    FlagIcon: react_northstar_1.FlagIcon,
    FluidIcon: react_northstar_1.FluidIcon,
    FluidFileIcon: react_northstar_1.FluidFileIcon,
    FontColorIcon: react_northstar_1.FontColorIcon,
    FontSizeIcon: react_northstar_1.FontSizeIcon,
    FormatIcon: react_northstar_1.FormatIcon,
    GalleryIcon: react_northstar_1.GalleryIcon,
    GalleryNewIcon: react_northstar_1.GalleryNewIcon,
    GalleryNewLargeIcon: react_northstar_1.GalleryNewLargeIcon,
    GeofenceArrivesIcon: react_northstar_1.GeofenceArrivesIcon,
    GeofenceLeavesIcon: react_northstar_1.GeofenceLeavesIcon,
    GeofenceArrivesOrLeavesIcon: react_northstar_1.GeofenceArrivesOrLeavesIcon,
    GiphyIcon: react_northstar_1.GiphyIcon,
    GlassesIcon: react_northstar_1.GlassesIcon,
    GridIcon: react_northstar_1.GridIcon,
    GroupVideoCallGridIcon: react_northstar_1.GroupVideoCallGridIcon,
    HandIcon: react_northstar_1.HandIcon,
    HeadsetIcon: react_northstar_1.HeadsetIcon,
    HighlightIcon: react_northstar_1.HighlightIcon,
    HorizontalRuleIcon: react_northstar_1.HorizontalRuleIcon,
    ImageAltTextIcon: react_northstar_1.ImageAltTextIcon,
    ImageLibraryIcon: react_northstar_1.ImageLibraryIcon,
    ImageUnavailableIcon: react_northstar_1.ImageUnavailableIcon,
    IndentIcon: react_northstar_1.IndentIcon,
    InfoIcon: react_northstar_1.InfoIcon,
    ItalicIcon: react_northstar_1.ItalicIcon,
    LeaveIcon: react_northstar_1.LeaveIcon,
    LightningIcon: react_northstar_1.LightningIcon,
    LikeIcon: react_northstar_1.LikeIcon,
    LinkIcon: react_northstar_1.LinkIcon,
    LiveIcon: react_northstar_1.LiveIcon,
    LiveOffIcon: react_northstar_1.LiveOffIcon,
    LocationIcon: react_northstar_1.LocationIcon,
    LockIcon: react_northstar_1.LockIcon,
    MarkAsUnreadIcon: react_northstar_1.MarkAsUnreadIcon,
    MeetingNewIcon: react_northstar_1.MeetingNewIcon,
    MeetingTimeIcon: react_northstar_1.MeetingTimeIcon,
    MegaphoneIcon: react_northstar_1.MegaphoneIcon,
    MentionIcon: react_northstar_1.MentionIcon,
    MenuIcon: react_northstar_1.MenuIcon,
    MergeCallsIcon: react_northstar_1.MergeCallsIcon,
    MessageSeenIcon: react_northstar_1.MessageSeenIcon,
    MicIcon: react_northstar_1.MicIcon,
    MicOffIcon: react_northstar_1.MicOffIcon,
    MicrophoneDisabledIcon: react_northstar_1.MicrophoneDisabledIcon,
    MicrosoftStreamIcon: react_northstar_1.MicrosoftStreamIcon,
    MoreIcon: react_northstar_1.MoreIcon,
    NoPresenterIcon: react_northstar_1.NoPresenterIcon,
    NotepadPersonIcon: react_northstar_1.NotepadPersonIcon,
    NotesIcon: react_northstar_1.NotesIcon,
    NotificationsMutedIcon: react_northstar_1.NotificationsMutedIcon,
    NumberListIcon: react_northstar_1.NumberListIcon,
    OcrOffIcon: react_northstar_1.OcrOffIcon,
    OcrOnIcon: react_northstar_1.OcrOnIcon,
    OneNoteColorIcon: react_northstar_1.OneNoteColorIcon,
    OneNoteIcon: react_northstar_1.OneNoteIcon,
    OneNoteMonoIcon: react_northstar_1.OneNoteMonoIcon,
    OneDriveIcon: react_northstar_1.OneDriveIcon,
    OptionsIcon: react_northstar_1.OptionsIcon,
    OutdentIcon: react_northstar_1.OutdentIcon,
    OutlookColorIcon: react_northstar_1.OutlookColorIcon,
    OpenOutsideIcon: react_northstar_1.OpenOutsideIcon,
    PanoramaIcon: react_northstar_1.PanoramaIcon,
    PanoramaOffIcon: react_northstar_1.PanoramaOffIcon,
    PaperclipIcon: react_northstar_1.PaperclipIcon,
    ParticipantAddIcon: react_northstar_1.ParticipantAddIcon,
    ParticipantRemoveIcon: react_northstar_1.ParticipantRemoveIcon,
    PauseIcon: react_northstar_1.PauseIcon,
    PauseThickIcon: react_northstar_1.PauseThickIcon,
    PhoneArrowIcon: react_northstar_1.PhoneArrowIcon,
    PhoneClockIcon: react_northstar_1.PhoneClockIcon,
    PhoneIcon: react_northstar_1.PhoneIcon,
    PlayIcon: react_northstar_1.PlayIcon,
    PlugsIcon: react_northstar_1.PlugsIcon,
    PollIcon: react_northstar_1.PollIcon,
    PopupIcon: react_northstar_1.PopupIcon,
    PowerPointColorIcon: react_northstar_1.PowerPointColorIcon,
    PowerPointIcon: react_northstar_1.PowerPointIcon,
    PresenceAvailableIcon: react_northstar_1.PresenceAvailableIcon,
    PresenceStrokeIcon: react_northstar_1.PresenceStrokeIcon,
    PresenterIcon: react_northstar_1.PresenterIcon,
    QnaIcon: react_northstar_1.QnaIcon,
    QuestionCircleIcon: react_northstar_1.QuestionCircleIcon,
    QuoteIcon: react_northstar_1.QuoteIcon,
    RadioButtonIcon: react_northstar_1.RadioButtonIcon,
    ReadAloudIcon: react_northstar_1.ReadAloudIcon,
    RaiseHandColoredIcon: react_northstar_1.RaiseHandColoredIcon,
    RaiseHandDisabledIcon: react_northstar_1.RaiseHandDisabledIcon,
    RaiseHandIcon: react_northstar_1.RaiseHandIcon,
    ReactionsIcon: react_northstar_1.ReactionsIcon,
    RedbangIcon: react_northstar_1.RedbangIcon,
    RedoIcon: react_northstar_1.RedoIcon,
    RemoveFormatIcon: react_northstar_1.RemoveFormatIcon,
    ReplyIcon: react_northstar_1.ReplyIcon,
    RetryIcon: react_northstar_1.RetryIcon,
    RobotIcon: react_northstar_1.RobotIcon,
    SaveIcon: react_northstar_1.SaveIcon,
    ScreencastIcon: react_northstar_1.ScreencastIcon,
    ScreenshareIcon: react_northstar_1.ScreenshareIcon,
    SearchIcon: react_northstar_1.SearchIcon,
    SendIcon: react_northstar_1.SendIcon,
    SettingsIcon: react_northstar_1.SettingsIcon,
    SettingsAudioIcon: react_northstar_1.SettingsAudioIcon,
    ShareAltIcon: react_northstar_1.ShareAltIcon,
    ShareGenericIcon: react_northstar_1.ShareGenericIcon,
    ShareLocationIcon: react_northstar_1.ShareLocationIcon,
    ShareToIcon: react_northstar_1.ShareToIcon,
    ShieldKeyholeIcon: react_northstar_1.ShieldKeyholeIcon,
    Shift24hIcon: react_northstar_1.Shift24hIcon,
    ShiftActivityIcon: react_northstar_1.ShiftActivityIcon,
    SkypeColorIcon: react_northstar_1.SkypeColorIcon,
    SkypeLogoIcon: react_northstar_1.SkypeLogoIcon,
    SpeakerMuteIcon: react_northstar_1.SpeakerMuteIcon,
    SpeakerPersonIcon: react_northstar_1.SpeakerPersonIcon,
    SpotlightIcon: react_northstar_1.SpotlightIcon,
    SpotlightStopIcon: react_northstar_1.SpotlightStopIcon,
    StarIcon: react_northstar_1.StarIcon,
    StickerIcon: react_northstar_1.StickerIcon,
    StrikeIcon: react_northstar_1.StrikeIcon,
    SurveyIcon: react_northstar_1.SurveyIcon,
    SwitchCameraIcon: react_northstar_1.SwitchCameraIcon,
    SyncIcon: react_northstar_1.SyncIcon,
    TableAddIcon: react_northstar_1.TableAddIcon,
    TableDeleteIcon: react_northstar_1.TableDeleteIcon,
    TableIcon: react_northstar_1.TableIcon,
    TabsIcon: react_northstar_1.TabsIcon,
    TagIcon: react_northstar_1.TagIcon,
    TeamCreateIcon: react_northstar_1.TeamCreateIcon,
    TeamsIcon: react_northstar_1.TeamsIcon,
    TeamsMonochromeIcon: react_northstar_1.TeamsMonochromeIcon,
    TenantWorkIcon: react_northstar_1.TenantWorkIcon,
    TenantPersonalIcon: react_northstar_1.TenantPersonalIcon,
    ThumbtackIcon: react_northstar_1.ThumbtackIcon,
    ThumbtackSlashIcon: react_northstar_1.ThumbtackSlashIcon,
    TiltPanZoomIcon: react_northstar_1.TiltPanZoomIcon,
    ToDoListIcon: react_northstar_1.ToDoListIcon,
    TranscriptIcon: react_northstar_1.TranscriptIcon,
    TranslationIcon: react_northstar_1.TranslationIcon,
    TrashCanIcon: react_northstar_1.TrashCanIcon,
    TriangleEndIcon: react_northstar_1.TriangleEndIcon,
    TriangleDownIcon: react_northstar_1.TriangleDownIcon,
    TriangleUpIcon: react_northstar_1.TriangleUpIcon,
    TvIcon: react_northstar_1.TvIcon,
    UnderlineIcon: react_northstar_1.UnderlineIcon,
    UndoIcon: react_northstar_1.UndoIcon,
    UrgentIcon: react_northstar_1.UrgentIcon,
    UserBlurIcon: react_northstar_1.UserBlurIcon,
    UserFriendsIcon: react_northstar_1.UserFriendsIcon,
    UserPhoneIcon: react_northstar_1.UserPhoneIcon,
    VideoCameraEmphasisIcon: react_northstar_1.VideoCameraEmphasisIcon,
    VideoLoadingIcon: react_northstar_1.VideoLoadingIcon,
    VideomailIcon: react_northstar_1.VideomailIcon,
    VideoProhibitedIcon: react_northstar_1.VideoProhibitedIcon,
    VisioColorIcon: react_northstar_1.VisioColorIcon,
    VisioIcon: react_northstar_1.VisioIcon,
    VolumeIcon: react_northstar_1.VolumeIcon,
    VolumeDownIcon: react_northstar_1.VolumeDownIcon,
    VolumeUpIcon: react_northstar_1.VolumeUpIcon,
    WandIcon: react_northstar_1.WandIcon,
    WhiteboardIcon: react_northstar_1.WhiteboardIcon,
    WindowMaximizeIcon: react_northstar_1.WindowMaximizeIcon,
    WindowMinimizeIcon: react_northstar_1.WindowMinimizeIcon,
    WindowRestoreIcon: react_northstar_1.WindowRestoreIcon,
    WordColorIcon: react_northstar_1.WordColorIcon,
    WordIcon: react_northstar_1.WordIcon,
    WorkOrSchoolIcon: react_northstar_1.WorkOrSchoolIcon,
    YammerIcon: react_northstar_1.YammerIcon,
    ZoomInIcon: react_northstar_1.ZoomInIcon,
    ZoomOutIcon: react_northstar_1.ZoomOutIcon,
    ZoomToFitIcon: react_northstar_1.ZoomToFitIcon,
};
var FocusableIcon = function (_a) {
    var content = _a.tooltip.content, locale = _a.locale, styles = _a.styles, iconProps = __rest(_a, ["tooltip", "locale", "styles"]);
    return (react_1.default.createElement(react_northstar_1.Tooltip, { content: (0, translations_1.getText)(locale, content), accessibility: react_northstar_1.tooltipAsLabelBehavior, trigger: react_1.default.createElement(react_northstar_1.Button, { text: true, styles: __assign(__assign({}, styles), { padding: "0.0625rem", height: "auto" }) },
            react_1.default.createElement(Icon, __assign({}, iconProps))) }));
};
exports.FocusableIcon = FocusableIcon;
var Icon = function (_a) {
    var icon = _a.icon, styles = _a.styles;
    var componentName = "".concat(icon, "Icon");
    if (Icons.hasOwnProperty(componentName)) {
        var IconComponent = Icons[componentName];
        return react_1.default.createElement(IconComponent, { outline: true, styles: styles });
    }
    else {
        if (process.env.NODE_ENV === "development")
            console.warn("No such icon available: ", icon);
        return null;
    }
};
exports.default = Icon;
//# sourceMappingURL=Icon.js.map