"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPhrasingTextContent = exports.getAllPhrasingTextContent = exports.phrasingHasFocusableElements = void 0;
var react_1 = __importDefault(require("react"));
var react_northstar_1 = require("@fluentui/react-northstar");
var Icon_1 = __importStar(require("./Icon"));
var translations_1 = require("../translations");
var get_1 = __importDefault(require("lodash/get"));
var phrasingHasFocusableElements = function (phrasingItems) {
    return (Array.isArray(phrasingItems) &&
        phrasingItems.findIndex(function (phrasingItem) {
            return phrasingItem && phrasingItem.hasOwnProperty("tooltip");
        }) >= 0);
};
exports.phrasingHasFocusableElements = phrasingHasFocusableElements;
var getAllPhrasingTextContent = function (phrasingItems) {
    return Array.isArray(phrasingItems)
        ? phrasingItems.reduce(function (acc, phrasingItem) {
            if (!phrasingItem)
                return acc;
            if ((0, get_1.default)(phrasingItem, "icon"))
                return acc;
            return acc + (0, translations_1.getAllText)(phrasingItem);
        }, "")
        : (0, translations_1.getAllText)(phrasingItems);
};
exports.getAllPhrasingTextContent = getAllPhrasingTextContent;
var getPhrasingTextContent = function (locale, phrasingItems) {
    return Array.isArray(phrasingItems)
        ? phrasingItems.reduce(function (acc, phrasingItem) {
            if (!phrasingItem)
                return acc;
            if ((0, get_1.default)(phrasingItem, "icon"))
                return acc;
            return acc + (0, translations_1.getText)(locale, phrasingItem);
        }, "")
        : (0, translations_1.getText)(locale, phrasingItems);
};
exports.getPhrasingTextContent = getPhrasingTextContent;
var defaultIconStyles = function (truncate) { return (__assign({}, (truncate ? { flex: "0 0 auto" } : { transform: "translateY(-0.1em)" }))); };
var defaultTextStyles = function (truncate, textSelectable) { return (__assign(__assign({}, (truncate && {
    flex: "0 1 auto",
    overflow: "hidden",
    textOverflow: "ellipsis",
})), (textSelectable && { pointerEvents: "all", cursor: "text" }))); };
var PhrasingGroup = function (_a) {
    var phrasingItems = _a.content, locale = _a.locale, iconStyles = _a.iconStyles, _b = _a.truncate, truncate = _b === void 0 ? false : _b, _c = _a.textSelectable, textSelectable = _c === void 0 ? false : _c;
    var phrasingElements = Array.isArray(phrasingItems) ? (phrasingItems.map(function (phrasingItem, i) {
        var styles = i === 0 ? {} : { marginLeft: ".5rem" };
        if (!phrasingItem)
            return null;
        if ((0, get_1.default)(phrasingItem, "icon")) {
            var finalStyles = __assign(__assign(__assign({}, defaultIconStyles(truncate)), iconStyles), styles);
            if (phrasingItem.hasOwnProperty("tooltip")) {
                return (react_1.default.createElement(Icon_1.FocusableIcon, __assign({}, phrasingItem, { locale: locale, styles: finalStyles })));
            }
            else {
                return (react_1.default.createElement(Icon_1.default, __assign({}, phrasingItem, { styles: finalStyles })));
            }
        }
        else {
            return (react_1.default.createElement(react_northstar_1.Text, __assign({}, {
                content: (0, translations_1.getText)(locale, phrasingItem),
                styles: __assign(__assign({}, defaultTextStyles(truncate, textSelectable)), styles),
            })));
        }
    })) : (react_1.default.createElement(react_northstar_1.Text, __assign({}, {
        content: (0, translations_1.getText)(locale, phrasingItems),
        styles: defaultTextStyles(truncate, textSelectable),
    })));
    return truncate ? (react_1.default.createElement(react_northstar_1.Flex, { vAlign: "center", wrap: false, children: phrasingElements, styles: { whiteSpace: "nowrap" } })) : (react_1.default.createElement(react_1.default.Fragment, { children: phrasingElements }));
};
exports.default = PhrasingGroup;
//# sourceMappingURL=Phrasing.js.map