var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useState } from "react";
import { Popup, Button, MoreIcon, Menu, mergeThemes, Provider as FluentUIThemeProvider, EyeSlashIcon, FilterIcon, AcceptIcon, } from "@fluentui/react-northstar";
import { TeamsTheme } from "../../themes";
import Icon from "../../lib/Icon";
import { getText } from "../../translations";
var getLocalTheme = function () {
    return {
        componentVariables: {
            PopupContent: function (_a) {
                var colorScheme = _a.colorScheme, borderRadius = _a.borderRadius, borderWidth = _a.borderWidth, shadowLevel1 = _a.shadowLevel1, shadowLevel4 = _a.shadowLevel4, theme = _a.theme;
                return ({
                    backgroundColor: colorScheme.grey.background,
                    backgroundColorHover: colorScheme.grey.background,
                    boxShadow: "".concat(shadowLevel1, ", ").concat(shadowLevel4),
                    borderRadius: borderRadius,
                    borderSize: borderWidth,
                    borderColor: theme === TeamsTheme.HighContrast
                        ? colorScheme.grey.backgroundFocus
                        : "transparent",
                    borderColorHover: theme === TeamsTheme.HighContrast
                        ? colorScheme.grey.backgroundFocus
                        : "transparent",
                });
            },
        },
        componentStyles: {
            Menu: {
                root: {
                    width: "100%",
                    marginRight: "0",
                    marginLeft: "0",
                    border: "none",
                    padding: "0 0.25rem",
                },
            },
            MenuDivider: {
                root: { margin: "0.25rem 0" },
            },
            PopupContent: {
                content: {
                    width: "12.5rem",
                    padding: "0",
                    boxShadow: " 0px 1.2px 3.6px rgba(0, 0, 0, 0.11), 0px 6.4px 14.4px rgba(0, 0, 0, 0.13)",
                },
            },
        },
    };
};
export var DashboardCallout = function (_a) {
    var widgetId = _a.widgetId, globalTheme = _a.globalTheme, _b = _a.calloutType, calloutType = _b === void 0 ? "overflow" : _b, widgetCalloutGroup = _a.widgetCalloutGroup, hideWidget = _a.hideWidget, setActiveFilter = _a.setActiveFilter, activeFilter = _a.activeFilter, t = _a.t, onInteraction = _a.onInteraction;
    var theme = mergeThemes(globalTheme, getLocalTheme());
    var _c = useState(false), open = _c[0], setOpen = _c[1];
    var hideWidgetAction = {
        id: "hide_widget",
        content: t["hide widget"],
        icon: React.createElement(EyeSlashIcon, null),
        onClick: function () { return hideWidget && hideWidget(widgetId); },
    };
    var menuItems = calloutType === "filter"
        ? widgetCalloutGroup
            ? widgetCalloutGroup.map(function (_a) {
                var id = _a.id, title = _a.title;
                var selected = activeFilter === id;
                return {
                    key: id,
                    role: "option",
                    "aria-selected": selected,
                    content: getText(t.locale, title),
                    icon: (React.createElement(AcceptIcon, { outline: true, styles: { visibility: selected ? "visible" : "hidden" } })),
                    onClick: function () {
                        setActiveFilter && setActiveFilter(id);
                        setOpen(false);
                    },
                };
            })
            : []
        : widgetCalloutGroup
            ? __spreadArray(__spreadArray([], widgetCalloutGroup.map(function (_a) {
                var id = _a.id, icon = _a.icon, title = _a.title;
                return __assign(__assign({ key: id, content: getText(t.locale, title) }, (icon && { icon: React.createElement(Icon, { icon: icon }) })), (onInteraction && {
                    onClick: function () {
                        onInteraction({
                            event: "click",
                            target: "action",
                            widget: widgetId,
                            action: id,
                        });
                        setOpen(false);
                    },
                }));
            }), true), (hideWidget ? [{ kind: "divider" }, hideWidgetAction] : []), true) : [hideWidgetAction];
    return (React.createElement(FluentUIThemeProvider, { theme: theme }, (hideWidget || widgetCalloutGroup) && (React.createElement(Popup, { offset: [0, 0], position: "below", open: open, onOpenChange: function (_, props) { return setOpen(!!(props === null || props === void 0 ? void 0 : props.open)); }, trigger: React.createElement(Button, { text: true, iconOnly: true, "aria-label": t["more"], icon: calloutType === "filter" ? (React.createElement(FilterIcon, { outline: true })) : (React.createElement(MoreIcon, { outline: true })), styles: {
                margin: "0 -0.35rem",
            } }), content: {
            styles: { width: "12.5rem" },
            content: React.createElement(Menu, { items: menuItems, vertical: true }),
        }, trapFocus: {
            firstFocusableSelector: ".extended-toolbar__filters-menu__tree [data-is-focusable=true]",
        } }))));
};
//# sourceMappingURL=DashboardCallout.js.map