import { SvgIconProps } from "@fluentui/react-icons-northstar";
import { IFocusableIconProps, IIconProps } from "./Icon";
import { TLocale, TTextObject } from "../translations";
/**
 * An ordered collection of elements that render inline as content.
 * @public
 */
export declare type TPhrasingContent = TPhrasingProps[] | TTextObject;
export declare type TPhrasingProps = IIconProps | IFocusableIconProps | TTextObject;
export interface IPhrasingProps {
    content: TPhrasingContent;
    locale: TLocale;
    truncate?: boolean;
    textSelectable?: boolean;
}
interface IPhrasingComponentProps extends IPhrasingProps {
    iconStyles?: Pick<SvgIconProps, "styles">;
}
export declare const phrasingHasFocusableElements: (phrasingItems: TPhrasingContent) => boolean;
export declare const getAllPhrasingTextContent: (phrasingItems: TPhrasingContent) => string;
export declare const getPhrasingTextContent: (locale: TLocale, phrasingItems: TPhrasingContent) => string;
declare const PhrasingGroup: ({ content: phrasingItems, locale, iconStyles, truncate, textSelectable, }: IPhrasingComponentProps) => JSX.Element;
export default PhrasingGroup;
//# sourceMappingURL=Phrasing.d.ts.map