import { TeamsTheme } from "../constants";
/**
 * Color palette for the following new themes.
 *
 * TFL Default - tfl-default
 * TFL Dark - tfl-dark
 * TFW 2 Default - defaultV2
 * TFW 2 Dark - darkV2
 *
 * Design spec at
 *
 * https://www.figma.com/file/bD1cO42H6KuWwpyEeNWoIz/Shell20-ShipPlan-POR?node-id=0%3A1
 */
export declare const colorPaletteV2: {
    black: string;
    white: string;
    grey: {
        25: string;
        50: string;
        100: string;
        150: string;
        200: string;
        220: string;
        230: string;
        250: string;
        270: string;
        300: string;
        310: string;
        350: string;
        400: string;
        430: string;
        440: string;
        450: string;
        460: string;
        500: string;
        550: string;
        600: string;
        650: string;
        700: string;
        750: string;
        800: string;
        850: string;
        870: string;
        900: string;
        910: string;
    };
    brand: {
        50: string;
        100: string;
        200: string;
        300: string;
        400: string;
        450: string;
        500: string;
        600: string;
        700: string;
        800: string;
        900: string;
        1000: string;
    };
};
declare const _default: {
    theme: TeamsTheme;
    colors: {
        black: string;
        white: string;
        grey: {
            25: string;
            50: string;
            100: string;
            150: string;
            200: string;
            220: string;
            230: string;
            250: string;
            270: string;
            300: string;
            310: string;
            350: string;
            400: string;
            430: string;
            440: string;
            450: string;
            460: string;
            500: string;
            550: string;
            600: string;
            650: string;
            700: string;
            750: string;
            800: string;
            850: string;
            870: string;
            900: string;
            910: string;
        };
        brand: {
            50: string;
            100: string;
            200: string;
            300: string;
            400: string;
            450: string;
            500: string;
            600: string;
            700: string;
            800: string;
            900: string;
            1000: string;
        };
    };
    /**
     * Design spec at
     * https://www.figma.com/file/bD1cO42H6KuWwpyEeNWoIz/Shell20-ShipPlan-POR?node-id=0%3A1
     */
    colorScheme: {
        elevations: {
            2: string;
            4: string;
            8: string;
            16: string;
            32: string;
            64: string;
        };
        default: {
            foreground: string;
            foreground1: string;
            foreground2: string;
            foreground3: string;
            foreground4: string;
            background: string;
            background1: string;
            background2: string;
            background3: string;
            background4: string;
            background5: string;
            border: string;
            border1: string;
            border2: string;
            border3: string;
            foregroundHover: string;
            foregroundHover1: string;
            foregroundHover2: string;
            backgroundHover: string;
            backgroundHover1: string;
            backgroundHover2: string;
            backgroundHover3: string;
            backgroundHover4: string;
            borderHover: string;
            foregroundPressed: string;
            backgroundPressed: string;
            foregroundActive: string;
            foregroundActive1: string;
            backgroundActive: string;
            backgroundActive1: string;
            borderActive: string;
            borderFocus: string;
            borderFocusWithin: string;
            foregroundDisabled: string;
            foregroundDisabled1: string;
            borderDisabled: string;
            backgroundDisabled: string;
            backgroundDisabled1: string;
        };
        brand: {
            background: string;
            background1: string;
            background2: string;
            background3: string;
            background4: string;
            foreground: string;
            foreground1: string;
            foreground2: string;
            foreground3: string;
            foreground4: string;
            border: string;
            border1: string;
            border2: string;
            foregroundHover: string;
            foregroundHover1: string;
            foregroundHover2: string;
            borderHover: string;
            backgroundHover: string;
            backgroundHover1: string;
            foregroundPressed: string;
            foregroundPressed1: string;
            backgroundPressed: string;
            borderPressed: string;
            foregroundActive: string;
            foregroundActive1: string;
            foregroundActive2: string;
            backgroundActive: string;
            backgroundActive1: string;
            borderActive: string;
            borderActive1: string;
            borderActive2: string;
            foregroundFocus: string;
            foregroundFocus1: string;
            foregroundFocus2: string;
            foregroundFocus3: string;
            foregroundFocus4: string;
            backgroundFocus: string;
            backgroundFocus1: string;
            backgroundFocus2: string;
            backgroundFocus3: string;
            borderFocus: string;
            borderFocus1: string;
            borderFocusWithin: string;
            foregroundDisabled: string;
            foregroundDisabled1: string;
            borderDisabled: string;
            backgroundDisabled: string;
            backgroundDisabled1: string;
        };
    };
};
/**
 * Site variable overrides for the TFW 2 default theme
 */
export default _default;
//# sourceMappingURL=site-variables.d.ts.map